package com.kingdee.eas.custom.messageWebService;

import com.alibaba.fastjson.JSONObject;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.ormapping.ObjectUuidPK;
import com.kingdee.bos.util.BOSUuid;
import com.kingdee.bos.workflow.metas.AssignFactory;
import com.kingdee.bos.workflow.metas.AssignInfo;
import com.kingdee.bos.workflow.metas.IAssign;
import com.kingdee.bos.workflow.metas.WfAssignmentState;
import com.kingdee.eas.base.message.*;
import com.kingdee.eas.base.message.webservice.MessageWebServiceDao;
import com.kingdee.eas.base.message.webservice.WSMessage;
import com.kingdee.eas.base.message.webservice.WfrAssignMessage;
import com.kingdee.eas.base.message.webservice.WfrProcMessage;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import okhttp3.*;
import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

import java.util.Properties;

/**
 * @Description OAϢ  ProcessWebService
 * @Date 2024/10/29 13:38
 * @Created by Heyuan
 */
public class OAMessageWebServiceDao implements MessageWebServiceDao {
    private static Logger logger = Logger.getLogger(OAMessageWebServiceDao.class);
    private Properties prop = new Properties();
    private final String MBOSURL = "https://mbos.kdeascloud.com/mbos/mbosw/getWorkflowUrl?assignId={0}&eid={1}&storeEid={2}&name=approveui.navui&billID={3}";
    //mbosҳ
    private final String MBOSAPPROVECENTERURL = "https://mbos.kdeascloud.com/mbos/page/loadPage?appid=10036&eid={0}&path=lczs2&name=lczshome.navui";
    String propPath = System.getProperty("EAS_HOME") + "/server/properties/scy/receiveOAConfig.properties";

    public OAMessageWebServiceDao() {
        try {
            prop.load(new FileInputStream(propPath));
        } catch (Exception e) {
            e.printStackTrace();
            throw new RuntimeException("OAϢ ȡļʧ!" + e.getMessage());
        }
    }

    /**
     * Ϣ
     *
     * @param message
     * @return
     */
    @Override
    public boolean addMessage(WSMessage message) {
        logger.error("*********OAMessageWebServiceDao addMessage Ϣʼ**********");
        return sendMessage(message, "0", "0");
    }


    /**
     * ɾϢ
     *
     * @param s
     * @return
     */
    @Override
    public boolean removeMessage(String s) {
        logger.error("*********OAMessageWebServiceDao removeMessage111 Ϣʼ**********");
        logger.error("*********OAMessageWebServiceDao s " + s);
        return false;
    }


    /**
     * ɾϢ
     *
     * @param s
     * @param context
     * @return
     */
    @Override
    public boolean removeMessage(String s, Context context) {
        logger.error("*********OAMessageWebServiceDao removeMessage222 Ϣʼ**********");
        logger.error("*********OAMessageWebServiceDao s " + s);
        return false;
    }

    /**
     * Ϣ
     *
     * @param s
     * @return
     */
    @Override
    public boolean updateMessage(String s) {
        logger.error("*********OAMessageWebServiceDao updateMessages444 Ϣʼ**********");
        logger.error("*********OAMessageWebServiceDao s " + s);
        return false;
    }

    /**
     * Ϣ
     *
     * @param s
     * @param context
     * @return
     */
    @Override
    public boolean updateMessage(String s, Context context) {
        logger.error("*********OAMessageWebServiceDao updateMessages3333 Ϣʼ**********");
        logger.error("*********OAMessageWebServiceDao s " + s);
        return false;
    }

    /**
     * @param s
     * @param msgStatus
     * @return
     */
    @Override
    public boolean updateMessages(String s, MsgStatus msgStatus) {
        logger.error("*********OAMessageWebServiceDao updateMessages111 Ϣʼ**********");
        logger.error("*********OAMessageWebServiceDao s " + s);
        logger.error("*********OAMessageWebServiceDao msgStatus " + msgStatus.getAlias());
        return false;
    }

    @Override
    public boolean updateMessages(String id, MsgStatus msgStatus, Context ctx) {
        logger.error("*********OAMessageWebServiceDao updateMessages2222 Ϣʼ**********");
        logger.error("*********OAMessageWebServiceDao id " + id);
        logger.error("*********OAMessageWebServiceDao msgStatus " + msgStatus.getAlias());
        BOSUuid bosId = BOSUuid.read(id);
        String bosType = bosId.getType().toString();
        logger.error("*********OAMessageWebServiceDao bosType " + bosType);
        if ("9623EB51".equals(bosType)) {
            try {
                //Ķ
                IAssignRead assignReadIns = AssignReadFactory.getLocalInstance(ctx);
                AssignReadInfo assignReadInfo = assignReadIns.getAssignReadInfo(new ObjectUuidPK(id));
                String assignID = assignReadInfo.getAssignID().toString();
                IAssign iAssign = AssignFactory.getLocalInstance(ctx);
                IPerson iPerson = PersonFactory.getLocalInstance(ctx);
                AssignInfo assignInfo = iAssign.getValue(new ObjectUuidPK(assignID));
                WSMessage wsMessage = new WSMessage();
                wsMessage.setMsgID(id);
                wsMessage.setTitle(assignInfo.getSubject());
                wsMessage.setBillId(assignInfo.getBizObjID());
                wsMessage.setContext(ctx);
                String priorPerformerID = assignInfo.getPriorPerformerID();
                PersonInfo sender = iPerson.getPersonInfo(new ObjectUuidPK(priorPerformerID));
                wsMessage.setSenderNumber(sender.getNumber());
                wsMessage.setSender(sender.getName());
                String personEmpId = assignInfo.getPersonEmpID().toString();
                PersonInfo reciever = iPerson.getPersonInfo(new ObjectUuidPK(personEmpId));
                wsMessage.setReceivers(reciever.getName());
                wsMessage.setRecieveNumber(reciever.getNumber());
                wsMessage.setRecieverID(personEmpId);
                if (MsgStatus.READED.equals(msgStatus)) {
                    //Ѷ
                    return sendMessage(wsMessage, "0", "1");
                } else {
                    return sendMessage(wsMessage, "0", "0");
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
        return false;
    }

    @Override
    public boolean addInitiatorMessage(WfrProcMessage wfrProcMessage) {
        logger.error("*********OAMessageWebServiceDao addInitiatorMessage Ϣʼ**********");
        return false;
    }

    /**
     * ʱ
     * ֮ᴥ com.kingdee.eas.custom.messageWebService.OAMessageWebServiceDao#removeMessage(java.lang.String, com.kingdee.bos.Context)
     * ֮ᴥ com.kingdee.eas.custom.messageWebService.OAMessageWebServiceDao#addInitiatorMessage(com.kingdee.eas.base.message.webservice.WfrProcMessage)
     *
     * @param wfrAssignMessage
     * @return
     */
    @Override
    public boolean addCompletedMessage(WfrAssignMessage wfrAssignMessage) {
        try {
            logger.error("*********OAMessageWebServiceDao addCompletedMessage Ϣʼ**********");
            String assignId = wfrAssignMessage.getAssignId();
            logger.error("*********OAMessageWebServiceDao assignId " + assignId);
            String assignSubject = wfrAssignMessage.getAssignSubject();
            String billID = wfrAssignMessage.getBillID();
            String handler = wfrAssignMessage.getHandler();
            String handlerNumber = wfrAssignMessage.getHandlerNumber();
            String state = wfrAssignMessage.getState();
            logger.error("*********OAMessageWebServiceDao state " + state);
            WfAssignmentState stateEnum = WfAssignmentState.getEnum(state);
            Context ctx = wfrAssignMessage.getCtx();
            IAssignRead iAssignRead = AssignReadFactory.getLocalInstance(ctx);
            AssignReadCollection assignReadCollection = iAssignRead.getAssignReadCollection("where assignID='" + assignId + "'");
            String msgId = null;
            if (assignReadCollection.size() > 0) {
                msgId = assignReadCollection.get(0).getId().toString();
            } else {
                throw new RuntimeException("δҵӦĶ  assignId: " + assignId);
            }
            if (WfAssignmentState.CANCELED.equals(stateEnum)) {
                //ȡɾOA
                return deleteMessage(msgId, handlerNumber);
            } else if (WfAssignmentState.COMPLETED.equals(stateEnum) || WfAssignmentState.REJECTED.equals(stateEnum)) {
                //ɻѾܾOAϢΪѰ
                WSMessage wsMessage = new WSMessage();
                wsMessage.setMsgID(msgId);
                wsMessage.setTitle(assignSubject);
                wsMessage.setBillId(billID);
                wsMessage.setContext(ctx);
                wsMessage.setSenderNumber(wfrAssignMessage.getInitiatorNumber());
                wsMessage.setSender(wfrAssignMessage.getInitiator());
                wsMessage.setReceivers(handler);
                wsMessage.setRecieveNumber(handlerNumber);
                wsMessage.setRecieverID(wfrAssignMessage.getHandlerId());
                return sendMessage(wsMessage, "2", "1");
            }
        } catch (BOSException e) {
            e.printStackTrace();
        }
        return false;
    }

    /**
     * @param message
     * @param isremark ̴״̬
     * @param viewtype ̲鿴״̬
     * @return
     */
    private boolean sendMessage(WSMessage message, String isremark, String viewtype) {
        try {
            String serverName = prop.getProperty("serverName");
            String receiveOAPath = prop.getProperty("receiveOAPath");
            if (StringUtils.isEmpty(receiveOAPath)) {
                throw new RuntimeException("OAϢ,첽ϢַΪ! ļ: " + propPath);
            }
            JSONObject params = new JSONObject();
            String syscode = prop.getProperty("syscode", "SHR");
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date date = new Date();
            String now = sdf.format(date);
            params.put("syscode", syscode);//칹ϵͳʶ
            params.put("flowid", message.getMsgID());//ʵid
            params.put("requestname", message.getTitle());//
            MsgType type = message.getType();
            if (type != null) {
                params.put("workflowname", type.getAlias());//
            } else {
                params.put("workflowname", "");
            }
            String billId = message.getBillId();
            logger.error("billId: " + billId);
            String assignID = null;
            if (!StringUtils.isEmpty(message.getMsgID())) {
                IAssignRead assignReadIns = AssignReadFactory.getLocalInstance(message.getContext());
                AssignReadInfo assignReadInfo = assignReadIns.getAssignReadInfo(new ObjectUuidPK(message.getMsgID()));
                assignID = assignReadInfo.getAssignID().toString();
            }

            params.put("pcurl", getPcUrl(serverName, assignID));//PCַ·/ͷ
            params.put("appurl", getAppUrl(message.getContext(), serverName, assignID));//APPַ·/ͷ
            params.put("nodename", "sHR");//ƣڵƣ
            params.put("isremark", isremark);//̴״̬
            params.put("viewtype", viewtype);//̲鿴״̬
            params.put("creator", message.getSenderNumber());//ˣԭֵ
            params.put("createdatetime", now);//ʱ
            params.put("receiver", message.getRecieveNumber());//ˣԭֵ
            params.put("receivedatetime", now);//ʱ
            //ʱֶΣͻʹ̵߳ýӿڵʱ򣬸ݴֶжǷҪݣֹ󷢵ݱ֮ǰĸ
            params.put("receivets", String.valueOf(date.getTime()));
            logger.error("addMessage -> params: " + params);
            OkHttpClient client = new OkHttpClient();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, params.toString());
            Request request = new Request.Builder()
                    .url(receiveOAPath)
                    .post(body)
                    .addHeader("content-type", "application/json")
                    .build();
            Response response = client.newCall(request).execute();
            if (response.isSuccessful()) {
                String result = response.body().string();
                logger.error("addMessage -> result:" + result);
                JSONObject jsonObject = JSONObject.parseObject(result);
                String operResult = jsonObject.getString("operResult");
                if ("1".equals(operResult)) {
                    return true;
                } else {
                    logger.error(jsonObject.getString("message"));
                }
            } else {
                logger.error("OAϢ ʱ");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    /**
     * ȡpcַ
     *
     * @param serverName
     * @param assignID
     * @return
     * @throws BOSException
     * @throws EASBizException
     * @throws UnsupportedEncodingException
     */
    private String getPcUrl(String serverName, String assignID)
            throws UnsupportedEncodingException {
        StringBuilder pcurl = new StringBuilder();
        StringBuilder redirectUrl = new StringBuilder();
        pcurl.append(serverName).append("/shr/api/oAToSHR?redirect=");
        if (!StringUtils.isEmpty(assignID)) {
            redirectUrl.append(serverName).append("/easweb/webviews/workflow/transferApprove.jsp?AssignmentId=")
                    .append(assignID);
        } else {
            redirectUrl.append(serverName).append("/shr/dynamic.do?uipk=shr.perself.homepage");
        }
        pcurl.append(URLEncoder.encode(redirectUrl.toString(), "UTF-8"));
        return pcurl.toString();
    }

    /**
     * ȡappַ
     *
     * @param serverName
     * @param assignID
     * @return
     * @throws BOSException
     * @throws EASBizException
     * @throws UnsupportedEncodingException
     */
    private String getAppUrl(Context ctx, String serverName, String assignID)
            throws UnsupportedEncodingException, BOSException {
        StringBuilder appUrl = new StringBuilder();
        appUrl.append(serverName).append("/shr/api/oAToMBos?redirect=");
        String eid = prop.getProperty("eid");
        if (StringUtils.isEmpty(eid)) {
            throw new RuntimeException("OAϢ,eidΪ! ļ: " + propPath);
        }
        String redirectUrl = null;
        if (!StringUtils.isEmpty(assignID)) {
            IAssign iAssign = AssignFactory.getLocalInstance(ctx);
            AssignInfo assignInfo = iAssign.getValue(new ObjectUuidPK(assignID));
            String billId = assignInfo.getBizObjID();
            redirectUrl = MessageFormat.format(MBOSURL,
                    URLEncoder.encode(assignID, "UTF-8"),
                    eid,
                    eid,
                    URLEncoder.encode(billId, "UTF-8"));
        } else {
            redirectUrl = MessageFormat.format(MBOSAPPROVECENTERURL, eid);
        }
        appUrl.append(URLEncoder.encode(redirectUrl, "UTF-8"));
        return appUrl.toString();
    }


    /**
     * ɾ
     *
     * @param flowId
     * @param userId
     * @return
     */
    private boolean deleteMessage(String flowId, String userId) {
        try {
            OkHttpClient client = new OkHttpClient();
            JSONObject params = new JSONObject();
            String deleteMsgPath = prop.getProperty("deleteMsgPath");
            if (StringUtils.isEmpty(deleteMsgPath)) {
                throw new RuntimeException("ɾOAϢַΪ! ļ: " + propPath);
            }
            String syscode = prop.getProperty("syscode", "SHR");
            params.put("syscode", syscode);
            params.put("flowid", flowId);
            params.put("userid", userId);
            String paramsStr = params.toString();
            logger.error("OAMessageWebServiceDao  deleteMessage-> params:" + paramsStr);
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, paramsStr);
            Request request = new Request.Builder()
                    .url(deleteMsgPath)
                    .post(body)
                    .addHeader("content-type", "application/json")
                    .build();
            Response response = client.newCall(request).execute();
            if (response.isSuccessful()) {
                String result = response.body().string();
                logger.error("deleteMessage -> result:" + result);
                JSONObject jsonObject = JSONObject.parseObject(result);
                String operResult = jsonObject.getString("operResult");
                if ("1".equals(operResult)) {
                    return true;
                } else {
                    logger.error(jsonObject.getString("message"));
                }
            } else {
                logger.error("ɾOAϢ ʱ");
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        return false;
    }


}
