package com.kingdee.eas.hr.affair.app;

import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.common.EASBizException;
import com.kingdee.eas.custom.synctask.SyncTranForOAFacadeFactory;
import com.kingdee.eas.framework.CoreBaseInfo;
import com.kingdee.eas.hr.affair.FluctuationBizBillEntryCollection;
import com.kingdee.eas.hr.affair.FluctuationBizBillEntryInfo;
import com.kingdee.eas.hr.affair.FluctuationBizBillInfo;
import org.apache.log4j.Logger;

/**
 * @author qingwu
 * @date 2024/10/26
 * @apiNote
 */
public class FluctuationBizBillControllerBeanEx extends FluctuationBizBillControllerBean {
    Logger logger = Logger.getLogger(FluctuationBizBillControllerBeanEx.class);

    @Override
    public IObjectPK submitEffect(Context ctx, CoreBaseInfo model) throws BOSException, EASBizException {
        IObjectPK iObjectPK = super.submitEffect(ctx, model);
        logger.error("FluctuationBizBillControllerBeanEx-----------afterSubmit---------------");
        FluctuationBizBillInfo fluctuationBizBillInfo = (FluctuationBizBillInfo) model;
        FluctuationBizBillEntryCollection entrys = fluctuationBizBillInfo.getEntrys();
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < entrys.size(); i++) {
            FluctuationBizBillEntryInfo fluctuationBizBillEntryInfo = entrys.get(i);
            PersonInfo person = fluctuationBizBillEntryInfo.getPerson();
            sb.append(person.getId().toString()).append(",");
        }
        sb.deleteCharAt(sb.lastIndexOf(","));
        logger.error("afterSubmit---------------person------" + sb.toString());
        try {
            if (sb.length() > 0) {
                SyncTranForOAFacadeFactory.getLocalInstance(ctx).syncPersonToOA(sb.toString(), null);
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new BOSException("ͬԱ" + e.getMessage());
        }
        return iObjectPK;
    }
}
