package com.kingdee.eas.custom.synctask.handler;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.kingdee.bos.BOSException;
import com.kingdee.bos.Context;
import com.kingdee.bos.dao.IObjectPK;
import com.kingdee.bos.metadata.entity.EntityViewInfo;
import com.kingdee.bos.metadata.entity.FilterInfo;
import com.kingdee.bos.metadata.entity.FilterItemInfo;
import com.kingdee.bos.metadata.entity.SelectorItemInfo;
import com.kingdee.bos.metadata.query.util.CompareType;
import com.kingdee.eas.base.permission.UserInfo;
import com.kingdee.eas.basedata.person.IPerson;
import com.kingdee.eas.basedata.person.PersonCollection;
import com.kingdee.eas.basedata.person.PersonFactory;
import com.kingdee.eas.basedata.person.PersonInfo;
import com.kingdee.eas.custom.sso.ExpiringMapCache;
import com.kingdee.eas.custom.synctask.SyncTranForMJFacadeFactory;
import com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils;
import com.kingdee.eas.framework.CoreBaseCollection;
import com.kingdee.eas.hr.ats.*;
import com.kingdee.shr.ats.web.handler.PunchCardRecordListHandler;
import com.kingdee.shr.base.syssetting.context.SHRContext;
import com.kingdee.shr.base.syssetting.exception.ShrWebBizException;
import com.kingdee.util.StringUtils;
import okhttp3.*;
import org.apache.log4j.Logger;
import org.springframework.ui.ModelMap;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.FileInputStream;
import java.io.IOException;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * @Description TODO
 * @Date 2024/10/29 17:51
 * @Created by 30489
 */
public class PunchCardRecordListHandlerEx extends PunchCardRecordListHandler {
    Logger logger = Logger.getLogger(PunchCardRecordListHandlerEx.class);
    private Context ctx = SHRContext.getInstance().getContext();
    private Properties propt = new Properties();

    private static ExpiringMapCache<String, String> cache = new ExpiringMapCache();
    private long durationInMillis = 84600000;

    public PunchCardRecordListHandlerEx() throws BOSException {
        String syncOAConfigPath = System.getProperty("EAS_HOME") + "/server/properties/scy/syncMJConfig.properties";
        try {
            propt.load(new FileInputStream(syncOAConfigPath));
        } catch (IOException e) {
            e.printStackTrace();
            String errorMsg = "ȡļã" + syncOAConfigPath + "   " + e.getMessage();
            throw new BOSException(errorMsg);
        }
    }

    /**
     * ȡݿ򿨼¼
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws BOSException
     */
    public void syncZKPunchCardDataAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException {
        SyncTranForMJFacadeFactory.getLocalInstance(ctx).syncPunchRecordFromMJ(null, null);
        //syncZKPunchCardData(request, response, modelMap);
    }

    /**
     * ȡŽ򿨼¼
     *
     * @param request
     * @param response
     * @param modelMap
     * @throws BOSException
     */
    public void syncPunchRecordFromMJAction(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) throws BOSException, ShrWebBizException {
        //SyncTranForMJFacadeFactory.getLocalInstance(ctx).syncAccessRecord(null, null);
        //syncZKPunchCardData(request, response, modelMap);
        _syncAccessRecord(ctx, null, null);
    }

    /**
     * ͬŽ򿨼¼
     *
     * @param ctx
     * @param startDate
     * @param endDate
     * @throws BOSException
     */
    protected void _syncAccessRecord(Context ctx, String startDate, String endDate) throws ShrWebBizException {
        logger.error("_syncAccessRecord------");
        Properties properties = new Properties();
        properties.put("version", propt.getProperty("version"));
        properties.put("tenantCode", propt.getProperty("tenantCode"));//⻧ţƽ̨ṩ
        properties.put("language", propt.getProperty("language"));//
        properties.put("tenantSecret", propt.getProperty("tenantSecret"));//Կ
        properties.put("account", propt.getProperty("account"));//ӿ˺
        properties.put("password", propt.getProperty("password"));//ӿ˺
        properties.put("getTokenPath", propt.getProperty("getTokenPath"));//ȡtokenӿڵַ


        try {
            JSONObject params = new JSONObject();
            params.put("count", "100");
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
            //ȡǰ
            Calendar calendar = Calendar.getInstance();
            calendar.add(Calendar.DAY_OF_YEAR, -3);
            Date threeDaysAgoDate = calendar.getTime();
            //Date parse = sdf.parse("2022-01-01");
            params.put("rowTimeStamp", threeDaysAgoDate.getTime());
            String payload = params.toJSONString();
            Map<String, String> headers = getHeader(payload, false);

            OkHttpClient client = new OkHttpClient.Builder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, payload);
            Request.Builder requestBuilder = new Request.Builder()
                    .url(propt.getProperty("getMJPath"))
                    .method("POST", body)
                    .addHeader("Content-Type", "application/json");
            // ͷ
            for (Map.Entry<String, String> header : headers.entrySet()) {
                requestBuilder.header(header.getKey(), header.getValue());
            }
            Response response = client.newCall(requestBuilder.build()).execute();
            logger.error("response----" + response.isSuccessful());
            if (response.isSuccessful()) {
                //token,ÿεýӿںˢtoken
                resetToken();
                ObjectMapper mapper = new ObjectMapper();
                String resultBody = response.body().string();
                logger.error("resultBody----" + resultBody);
                JSONObject result = JSONObject.parseObject(resultBody);
                logger.error("respMap----" + result);
                if (result.get("code").equals("0") || Integer.parseInt(result.get("code").toString()) == 0) {
                    String data = result.get("data").toString();
                    JSONArray jsonArray = JSONArray.parseArray(result.get("data").toString());
                    logger.error("jsonArray---" + jsonArray.toString());
                    logger.error("jsonArray---" + jsonArray.size());
                    IPerson iPerson = PersonFactory.getLocalInstance(ctx);
                    PersonCollection personCollection = iPerson.getPersonCollection("select number ");
                    Set set = new HashSet();
                    for (int i = 0; i < personCollection.size(); i++) {
                        PersonInfo personInfo = personCollection.get(i);
                        set.add(personInfo.getNumber().toString());
                    }
                    for (int i = 0; i < jsonArray.size(); i++) {
                        JSONObject resultData = jsonArray.getJSONObject(i);
                        //Ž򿨼¼
                        saveMJPunchCardData(ctx, resultData, set);
                    }
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
            throw new ShrWebBizException(e.getMessage());
        }
    }

    /**
     * Ž򿨼¼
     *
     * @param ctx
     * @param resultData
     */
    public void saveMJPunchCardData(Context ctx, JSONObject resultData, Set set) {
        logger.error("saveMJPunchCardData----");
        try {

            int success = 0;
            int error = 0;
            Set<String> setCardId = new HashSet();
            Set<String> EquNoSet = new HashSet();
            Timestamp minDateTime = null;
            Timestamp maxDateTime = null;
            CoreBaseCollection cardCollFinally = new CoreBaseCollection();
            CoreBaseCollection cardColl = new CoreBaseCollection();
            JSONArray formatErrorRecords = new JSONArray();
            //洢ͬ
            JSONArray duplicateRecords = new JSONArray();
            //洢Ϊյ
            JSONArray notExistRecords = new JSONArray();
            JSONArray seccussArray = new JSONArray();
            ++success;
            String personNumber = resultData.getString("empCode");//Ա
            String punchCardDate = resultData.getString("checkTime"); //ʱ
            String RecDate = punchCardDate.substring(0, 10);// 
            String RecTime = punchCardDate.substring(11, 19);// ʱ
            //String locationDetail = resultSet.getString("name"); //򿨵ص
            //String EquNo = resultSet.getString("EquNo"); //ڻ
            //String exceptionType = resultSet.getString("EquNo"); // /쳣
            //Date punchDate = HRTimeWebUtils.stringToShortDate(RecDate, true);
            Date punchDate = com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.stringToShortDate(RecDate, true);
            Timestamp punchCardTime = com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.stringToTimestamp(punchCardDate, true);
            // 
            if (punchCardDate != null && punchCardTime != null) {
                PunchCardRecordInfo cardInfo = new PunchCardRecordInfo();
                //ڻ
                cardInfo.setEquipmentNum("001");
                //ڱ
                cardInfo.setAttendanceNum(personNumber);
                //
                cardInfo.setPunchCardDate(punchDate);
                //ʱ
                cardInfo.setPunchCardTime(punchCardTime);
                // Դ
                cardInfo.setPunchCardSource(PunchCardSourceEnum.attenceMachine);
                // λ
                cardInfo.setPunchCardPlace((String) resultData.get("checkLocation"));
                // Ч
                PunchCardStateEnum punchCardStateEnum;
                if ((boolean) resultData.get("isActive")) {
                    punchCardStateEnum = PunchCardStateEnum.normal;
                } else {
                    punchCardStateEnum = PunchCardStateEnum.cancelled;
                }
                cardInfo.setPunchCardState(punchCardStateEnum);
                ////
                //cardInfo.setSimpleName(exceptionType);
                //
                //cardInfo.setDescription(exceptionType);

                EquNoSet.add("001");
                if (!StringUtils.isEmpty(personNumber)) {
                    if (!set.contains(personNumber)) {
                        return;
                    }
                    setCardId.add(personNumber);
                    cardColl.add(cardInfo);
                }

                if (minDateTime != null && maxDateTime != null) {
                    if (punchCardTime.getTime() < minDateTime.getTime()) {
                        minDateTime = punchCardTime;
                    } else if (punchCardTime.getTime() > maxDateTime.getTime()) {
                        maxDateTime = punchCardTime;
                    }
                } else {
                    minDateTime = punchCardTime;
                    maxDateTime = punchCardTime;
                }

            } else {
                formatErrorRecords.add(resultData);
            }
            // ڵ
            Map<String, AttendanceFileInfo> attendanceFileMap = AttendanceFileFactory.getLocalInstance(ctx).getPersonByAttendanceNum(setCardId);
            logger.error("attendanceFileMap-----" + attendanceFileMap);
            logger.error("setCardId-----" + setCardId);
            //ͬ
            PunchCardRecordCollection existColl = this.getExistedPunchCardRecordCollection(ctx, minDateTime, maxDateTime, setCardId);
            logger.error("existColl-----" + existColl.size());
            for (int i = 0; i < cardColl.size(); ++i) {
                Map map = new HashMap();
                // ԭʼ򿨼¼ʵ
                PunchCardRecordInfo cardInfo = (PunchCardRecordInfo) cardColl.get(i);
                JSONObject jsObject = new JSONObject();
                jsObject.put("deviceid", cardInfo.getEquipmentNum()); // deviceid --EquNo
                jsObject.put("userid", cardInfo.getAttendanceNum()); // userid --CardId
                jsObject.put("RecDate", com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.dateShortToString(cardInfo.getPunchCardDate())); //checkin_time --RecDate
                jsObject.put("RecTime", com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.timestampToString(cardInfo.getPunchCardTime()).substring(11)); //checkin_time --RecDate
                map.put("userid", cardInfo.getAttendanceNum());
                map.put("RecDate", com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.dateShortToString(cardInfo.getPunchCardDate()));
                map.put("RecTime", HRTimeWebUtils.timestampToString(cardInfo.getPunchCardTime()).substring(11));
                //ԱǷпڵ
                if (attendanceFileMap.containsKey(cardInfo.getAttendanceNum())) {
                    if (existColl.contains(cardInfo)) {
                        duplicateRecords.add(jsObject);
                    } else {
                        // λ ڻ ĵַ
                        cardInfo.setPunchCardPlace(cardInfo.getPunchCardPlace());
                        //Դ
                        cardInfo.setPunchCardSource(PunchCardSourceEnum.attenceMachine);
                        // ʵ
                        AttendanceFileInfo attendanceFileInfo = (AttendanceFileInfo) attendanceFileMap.get(cardInfo.getAttendanceNum());
                        // 
                        cardInfo.setProposer(attendanceFileInfo.getProposer());
                        // HR ֯
                        cardInfo.setHrOrgUnit(attendanceFileInfo.getHrOrgUnit());
                        //֯
                        cardInfo.setAdminOrgUnit(attendanceFileInfo.getAdminOrgUnit());
                        cardInfo.setCreator((UserInfo) ctx.get("UserInfo"));
                        cardInfo.setLastUpdateUser((UserInfo) ctx.get("UserInfo"));
                        cardInfo.setCreateTime(new Timestamp((new Date()).getTime()));
                        cardInfo.setLastUpdateTime(new Timestamp((new Date()).getTime()));
                        cardCollFinally.add(cardInfo);
                    }
                    seccussArray.add(map);
                } else {
                    ++error;
                    notExistRecords.add(jsObject);
                }
            }
            logger.error("cardCollFinally-----" + cardCollFinally.size());
            logger.error("success-----" + success);
            logger.error("error-----" + error);
            logger.error("notExistRecords--list---" + notExistRecords);
            logger.error("notExistRecords-----" + notExistRecords.size());
            logger.error("seccussArray--Size-----" + seccussArray.size());
            logger.error("seccussArray-----" + seccussArray);
            IObjectPK[] iObjectPKS = PunchCardRecordFactory.getLocalInstance(ctx).saveBatchData(cardCollFinally);
            logger.error("iObjectPKS----" + iObjectPKS.length);
        } catch (
                Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * token,ÿεýӿںˢtoken
     */
    private void resetToken() {
        String token = cache.get("token");
        if (org.apache.commons.lang3.StringUtils.isBlank(token)) {
            getTokenByRemote();
        } else {
            cache.put("token", token, durationInMillis);//23.5Сʱ
        }
    }

    /**
     * ȡͷ
     *
     * @param payload    bodyjsonַ
     * @param isGetToken Ƿȡtoken
     * @return
     */
    private Map<String, String> getHeader(String payload, boolean isGetToken) {
        Map<String, String> signParams = new HashMap<>();
        signParams.put("version", propt.getProperty("version"));
        signParams.put("transId", UUID.randomUUID().toString());
        signParams.put("timestamp", String.valueOf(System.currentTimeMillis() / 1000));
        signParams.put("tenantCode", propt.getProperty("tenantCode"));//⻧ţƽ̨ṩ
        signParams.put("language", propt.getProperty("language"));//֧
        if (!isGetToken) {
            signParams.put("token", getToken());
        }
        signParams.put("payload", payload);//ʱ body  json ַ
        //Կǩ֮ǰ
        signParams.put("tenantSecret", propt.getProperty("tenantSecret"));
        signParams.put("sign", createSign(signParams));
        return signParams;
    }

    /**
     * ȡtoken
     *
     * @return
     */
    private String getToken() {
        String token = cache.get("token");
        if (org.apache.commons.lang3.StringUtils.isBlank(token)) {
            token = getTokenByRemote();
        }
        return token;
    }

    /**
     * Զ̻ȡtoken
     *
     * @return
     */
    private String getTokenByRemote() {
        try {
            com.alibaba.fastjson.JSONObject params = new com.alibaba.fastjson.JSONObject();
            params.put("account", propt.getProperty("account"));
            String password = propt.getProperty("password");
            params.put("password", EncryptUtils.sha256(password, false));
            String payload = params.toJSONString();
            String getTokenPath = propt.getProperty("getTokenPath");

            Map<String, String> headers = getHeader(payload, true);
            OkHttpClient client = new OkHttpClient.Builder().build();
            MediaType mediaType = MediaType.parse("application/json");
            RequestBody body = RequestBody.create(mediaType, payload);
            Request.Builder requestBuilder = new Request.Builder()
                    .url(getTokenPath)
                    .method("POST", body)
                    .addHeader("Content-Type", "application/json");
            // ͷ
            for (Map.Entry<String, String> header : headers.entrySet()) {
                requestBuilder.header(header.getKey(), header.getValue());
            }
            Response response = client.newCall(requestBuilder.build()).execute();
            ObjectMapper mapper = new ObjectMapper();
            if (response.isSuccessful()) {
                Map<String, Object> result = mapper.readValue(response.body().string(), Map.class);
                if ("success".equals(result.get("msg"))) {
                    String token = (String) result.get("data");
                    cache.put("token", token, 84600000);//23.5Сʱ
                    return token;
                } else {
                    throw new RuntimeException("Զ̻ȡtoken: ");
                }
            } else {
                throw new RuntimeException("Զ̻ȡtoken: ");
            }
        } catch (IOException e) {
            e.printStackTrace();
            throw new RuntimeException("Զ̻ȡtoken: " + e.getMessage());
        }
    }

    /**
     * ǩ
     *
     * @param signParams ǩĲ
     * @return
     */
    private String createSign(Map<String, String> signParams) {
        String tenantSecret = signParams.get("tenantSecret");
        signParams.remove("tenantSecret");
        String linkStr = createLinkStr(signParams, "&");
        linkStr = linkStr + "&tenantSecret=" + tenantSecret;
        return EncryptUtils.sha256(linkStr, true);
    }

    /**
     * ַ
     *
     * @param params  
     * @param linkStr ַ
     * @return
     */
    private static String createLinkStr(Map<String, String> params, String linkStr) {
        List<String> keys = new ArrayList<String>(params.keySet());
        Collections.sort(keys);
        StringBuilder content = new StringBuilder();
        for (int i = 0; i < keys.size(); i++) {
            String key = keys.get(i);
            String value = params.get(key);
            if (i == keys.size() - 1) {
                content.append(key).append("=").append(value);
            } else {
                content.append(key).append("=").append(value).append(linkStr);
            }
        }
        return content.toString();
    }

    private PunchCardRecordCollection getExistedPunchCardRecordCollection(Context ctx, Timestamp minDateTime, Timestamp maxDateTime, Set<String> setCardId) throws BOSException {
        EntityViewInfo evi = new EntityViewInfo();
        FilterInfo fi = new FilterInfo();
        evi.setFilter(fi);
        evi.getSelector().add(new SelectorItemInfo("punchCardDate"));
        evi.getSelector().add(new SelectorItemInfo("punchCardTime"));
        evi.getSelector().add(new SelectorItemInfo("punchCardSource"));
        evi.getSelector().add(new SelectorItemInfo("equipmentNum"));
        evi.getSelector().add(new SelectorItemInfo("attendanceNum"));
        fi.getFilterItems().add(new FilterItemInfo("attendanceNum", setCardId, CompareType.INCLUDE));
        fi.getFilterItems().add(new FilterItemInfo("punchCardTime", maxDateTime, CompareType.LESS_EQUALS));
        fi.getFilterItems().add(new FilterItemInfo("punchCardTime", minDateTime, CompareType.GREATER_EQUALS));
        PunchCardRecordCollection existColl = PunchCardRecordFactory.getLocalInstance(ctx).getPunchCardRecordCollection(evi);
        return existColl;

    }
    //
    //public void syncZKPunchCardData(HttpServletRequest request, HttpServletResponse response, ModelMap modelMap) {
    //    //String url = "jdbc:sqlserver://10.0.3.23:1433;databaseName=kaoqin";
    //    String url = "jdbc:sqlserver://10.0.3.23:1433;databaseName=kaoqin;encrypt=true;trustServerCertificate=true;";
    //    String username = "zhongkong";
    //    String password = "6554+oijhh@";
    //    try {
    //        // SQL Server JDBC
    //        //Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
    //        // 
    //        Connection connection = DriverManager.getConnection(url, username, password);
    //        // Statement
    //        Statement statement = connection.createStatement();
    //        //ȡǰʱԼһǰʱ
    //        // ȡǰ
    //        Date now = new Date();
    //        Calendar calendar = Calendar.getInstance();
    //        calendar.setTime(now);
    //        // ·ݼ1ֻǼ򵥵·ݼ1ûпڱ߽ȸ
    //        calendar.add(Calendar.MONTH, -1);
    //        Date one_month_ago = calendar.getTime();
    //        // ȡǰ
    //        Date currentDate = new Date();
    //        // ʹCalendar
    //        Calendar calendarNewDate = Calendar.getInstance();
    //        calendarNewDate.setTime(currentDate);
    //        // ڵǰڻϼ1
    //        calendarNewDate.add(Calendar.DAY_OF_MONTH, 1);
    //        Date newDate = calendarNewDate.getTime();
    //        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
    //        String oneMOnthDate = sdf.format(one_month_ago);
    //        String nowDate = sdf.format(newDate);
    //        logger.error("PunchCardRecordEx----oneMOnthDate--" + oneMOnthDate);
    //        logger.error("PunchCardRecordEx----nowDate--" + nowDate);
    //        int success = 0;
    //        int error = 0;
    //        // ִвѯ
    //        //String query = "select \n" +
    //        //        "userinfo.SSN as personNumber ,\n" +
    //        //        "checkin.CHECKTIME as checkTime\n" +
    //        //        "from  checkinout as checkin\n" +
    //        //        "left join USERINFO as userinfo on userinfo.USERID = checkin.USERID\n" +
    //        //        "where checkin.CHECKTIME >='" + oneMOnthDate + "' and checkin.CHECKTIME <='" + nowDate + "'\n";
    //        String query = "\n" +
    //                " \n" +
    //                "select \n" +
    //                "userinfo.SSN as personNumber ,\n" +
    //                "checkin.CHECKTIME as checkTime\n" +
    //                "from  checkinout as checkin\n" +
    //                "left join USERINFO as userinfo on userinfo.USERID = checkin.USERID\n" +
    //                "where checkin.CHECKTIME >='2024-10-30' and checkin.CHECKTIME <='2024-10-31'\n" +
    //                " ";
    //        ResultSet resultSet = statement.executeQuery(query);
    //        Set<String> setCardId = new HashSet();
    //        Set<String> EquNoSet = new HashSet();
    //        Timestamp minDateTime = null;
    //        Timestamp maxDateTime = null;
    //        CoreBaseCollection cardCollFinally = new CoreBaseCollection();
    //        CoreBaseCollection cardColl = new CoreBaseCollection();
    //        JSONArray formatErrorRecords = new JSONArray();
    //        //洢ͬ
    //        JSONArray duplicateRecords = new JSONArray();
    //        //洢Ϊյ
    //        JSONArray notExistRecords = new JSONArray();
    //
    //        JSONArray seccussArray = new JSONArray();
    //
    //        // ѯ
    //        while (resultSet.next()) {
    //            ++success;
    //            String personNumber = resultSet.getString("personNumber");//Ա
    //            String punchCardDate = resultSet.getString("checkTime"); //ʱ
    //            String RecDate = punchCardDate.substring(0, 10);// 
    //            String RecTime = punchCardDate.substring(11, 19);// ʱ
    //            //String locationDetail = resultSet.getString("name"); //򿨵ص
    //            //String EquNo = resultSet.getString("EquNo"); //ڻ
    //            //String exceptionType = resultSet.getString("EquNo"); // /쳣
    //            //Date punchDate = HRTimeWebUtils.stringToShortDate(RecDate, true);
    //            Date punchDate = com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.stringToShortDate(RecDate, true);
    //            Timestamp punchCardTime = com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.stringToTimestamp(punchCardDate, true);
    //            // 
    //            if (punchCardDate != null && punchCardTime != null) {
    //                PunchCardRecordInfo cardInfo = new PunchCardRecordInfo();
    //                //ڻ
    //                cardInfo.setEquipmentNum("001");
    //                //ڱ
    //                cardInfo.setAttendanceNum(personNumber);
    //                //
    //                cardInfo.setPunchCardDate(punchDate);
    //                //ʱ
    //                cardInfo.setPunchCardTime(punchCardTime);
    //                // Դ
    //                cardInfo.setPunchCardSource(PunchCardSourceEnum.mobileRegistration);
    //                // λ
    //                cardInfo.setPunchCardPlace("ڻ");
    //                // Ч
    //                cardInfo.setPunchCardState(PunchCardStateEnum.normal);
    //                ////
    //                //cardInfo.setSimpleName(exceptionType);
    //                //
    //                //cardInfo.setDescription(exceptionType);
    //
    //                EquNoSet.add("001");
    //                if (!StringUtils.isEmpty(personNumber)) {
    //                    setCardId.add(personNumber);
    //                    cardColl.add(cardInfo);
    //                }
    //
    //                if (minDateTime != null && maxDateTime != null) {
    //                    if (punchCardTime.getTime() < minDateTime.getTime()) {
    //                        minDateTime = punchCardTime;
    //                    } else if (punchCardTime.getTime() > maxDateTime.getTime()) {
    //                        maxDateTime = punchCardTime;
    //                    }
    //                } else {
    //                    minDateTime = punchCardTime;
    //                    maxDateTime = punchCardTime;
    //                }
    //
    //            } else {
    //                formatErrorRecords.add(resultSet);
    //            }
    //        }
    //        // ڵ
    //        Map<String, AttendanceFileInfo> attendanceFileMap = AttendanceFileFactory.getLocalInstance(ctx).getPersonByAttendanceNum(setCardId);
    //        logger.error("attendanceFileMap-----" + attendanceFileMap);
    //        //ͬ
    //        PunchCardRecordCollection existColl = this.getExistedPunchCardRecordCollection(ctx, minDateTime, maxDateTime, setCardId);
    //        logger.error("existColl-----" + existColl.size());
    //        for (int i = 0; i < cardColl.size(); ++i) {
    //            Map map = new HashMap();
    //            // ԭʼ򿨼¼ʵ
    //            PunchCardRecordInfo cardInfo = (PunchCardRecordInfo) cardColl.get(i);
    //            JSONObject jsObject = new JSONObject();
    //            jsObject.put("deviceid", cardInfo.getEquipmentNum()); // deviceid --EquNo
    //            jsObject.put("userid", cardInfo.getAttendanceNum()); // userid --CardId
    //            jsObject.put("RecDate", com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.dateShortToString(cardInfo.getPunchCardDate())); //checkin_time --RecDate
    //            jsObject.put("RecTime", com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.timestampToString(cardInfo.getPunchCardTime()).substring(11)); //checkin_time --RecDate
    //            map.put("userid", cardInfo.getAttendanceNum());
    //            map.put("RecDate", com.kingdee.eas.custom.synctask.utils.HRTimeWebUtils.dateShortToString(cardInfo.getPunchCardDate()));
    //            map.put("RecTime", HRTimeWebUtils.timestampToString(cardInfo.getPunchCardTime()).substring(11));
    //            //ԱǷпڵ
    //            if (attendanceFileMap.containsKey(cardInfo.getAttendanceNum())) {
    //                if (existColl.contains(cardInfo)) {
    //                    duplicateRecords.add(jsObject);
    //                } else {
    //                    // λ ڻ ĵַ
    //                    cardInfo.setPunchCardPlace(cardInfo.getPunchCardPlace());
    //                    //Դ
    //                    cardInfo.setPunchCardSource(PunchCardSourceEnum.mobileRegistration);
    //                    // ʵ
    //                    AttendanceFileInfo attendanceFileInfo = (AttendanceFileInfo) attendanceFileMap.get(cardInfo.getAttendanceNum());
    //                    // 
    //                    cardInfo.setProposer(attendanceFileInfo.getProposer());
    //                    // HR ֯
    //                    cardInfo.setHrOrgUnit(attendanceFileInfo.getHrOrgUnit());
    //                    //֯
    //                    cardInfo.setAdminOrgUnit(attendanceFileInfo.getAdminOrgUnit());
    //                    cardInfo.setCreator((UserInfo) ctx.get("UserInfo"));
    //                    cardInfo.setLastUpdateUser((UserInfo) ctx.get("UserInfo"));
    //                    cardInfo.setCreateTime(new Timestamp((new Date()).getTime()));
    //                    cardInfo.setLastUpdateTime(new Timestamp((new Date()).getTime()));
    //                    cardCollFinally.add(cardInfo);
    //                }
    //                seccussArray.add(map);
    //            } else {
    //                ++error;
    //                notExistRecords.add(jsObject);
    //            }
    //        }
    //        logger.error("cardCollFinally-----" + cardCollFinally.size());
    //        logger.error("success-----" + success);
    //        logger.error("error-----" + error);
    //        logger.error("notExistRecords--list---" + notExistRecords);
    //        logger.error("notExistRecords-----" + notExistRecords.size());
    //        logger.error("seccussArray--Size-----" + seccussArray.size());
    //        logger.error("seccussArray-----" + seccussArray);
    //        IObjectPK[] iObjectPKS = PunchCardRecordFactory.getLocalInstance(ctx).saveBatchData(cardCollFinally);
    //        logger.error("iObjectPKS----" + iObjectPKS.length);
    //        JSONUtils.SUCCESS(iObjectPKS);
    //        // ر
    //        resultSet.close();
    //        statement.close();
    //        connection.close();
    //
    //    } catch (Exception e) {
    //        e.printStackTrace();
    //    }
    //}
    //
    //private PunchCardRecordCollection getExistedPunchCardRecordCollection(Context ctx, Timestamp minDateTime, Timestamp maxDateTime, Set<String> setCardId) throws BOSException {
    //    EntityViewInfo evi = new EntityViewInfo();
    //    FilterInfo fi = new FilterInfo();
    //    evi.setFilter(fi);
    //    evi.getSelector().add(new SelectorItemInfo("punchCardDate"));
    //    evi.getSelector().add(new SelectorItemInfo("punchCardTime"));
    //    evi.getSelector().add(new SelectorItemInfo("punchCardSource"));
    //    evi.getSelector().add(new SelectorItemInfo("equipmentNum"));
    //    evi.getSelector().add(new SelectorItemInfo("attendanceNum"));
    //    fi.getFilterItems().add(new FilterItemInfo("attendanceNum", setCardId, CompareType.INCLUDE));
    //    fi.getFilterItems().add(new FilterItemInfo("punchCardTime", maxDateTime, CompareType.LESS_EQUALS));
    //    fi.getFilterItems().add(new FilterItemInfo("punchCardTime", minDateTime, CompareType.GREATER_EQUALS));
    //    PunchCardRecordCollection existColl = PunchCardRecordFactory.getLocalInstance(ctx).getPunchCardRecordCollection(evi);
    //    return existColl;
    //
    //}

}
